program opensource001;

{$APPTYPE CONSOLE}

uses
  Classes,
  MimeMess,
  MimePart,
  SysUtils;

var
  oMimeMessage: TMimeMess;
  oMimePart: TMimePart;
  i, iPartCount, iHandled: Integer;
  bPartHandled: Boolean;

begin
  if ParamCount = 0 then
  begin
    WriteLN('');
    WriteLN('Please supply a filename for the message to be parsed.');
    WriteLN('');
  end
  else
  begin
    if not FileExists(ParamStr(1)) then
    begin
      WriteLN('');
      WriteLN('Sorry. "' + ExtractFilename(ParamStr(1)) + '" does not exist.');
      WriteLN('');
    end
    else
    begin
      oMimeMessage := TMimeMess.Create;
      try
        iHandled := 0;
        bPartHandled := false;
        try
          oMimeMessage.Lines.LoadFromFile(ParamStr(1));
          oMimeMessage.DecodeMessage;
          oMimeMessage.MessagePart.DecomposeParts; // Just doing like Synapse's help-files suggested :)
          iPartCount := oMimeMessage.MessagePart.GetSubPartCount;
          for i := 0 to Pred(iPartCount) do
          begin
            bPartHandled := false;
            oMimePart := oMimeMessage.MessagePart.GetSubPart(i);
            if oMimePart.PrimaryCode = MP_TEXT then // Ok, we're only interested in the message parts that appear to be in some sort of text
            begin
              oMimePart.DecodePart;
              iHandled := Succ(iHandled);
              if UpperCase(oMimePart.Secondary) = 'HTML' then
              begin
                oMimePart.PartBody.SaveToFile(ExtractFilename(ParamStr(1)) + '.' + IntToStr(iHandled) + '.htm');
              end
              else
              begin
                // If it's not HTML, we suggest it's plaintext. I know this is wrong, but for the sake of simplicity, let's...
                oMimePart.PartBody.SaveToFile(ExtractFilename(ParamStr(1)) + '.' + IntToStr(iHandled) + '.txt');
              end;
            end;
          end;
          WriteLN('');
          WriteLN('Done. ' + IntToStr(iHandled) + ' text/[something] -parts handled...');
          WriteLN('');
          bPartHandled := true;
        except
          // There was an exception and we do not intend to handle it. Life sucks.
          WriteLN('');
          WriteLN('Sorry. Unable to complete the message parsing.');
          if iHandled > 0 then
          begin
            if (iHandled > 0) and (bPartHandled) then
            begin
              // At least we managed to do *something* with the provided message :P
              WriteLN('We were able to handle ' + IntToStr(iHandled) + ' text/[something] -parts of the message.');
            end
            else if (iHandled > 0) then
            begin
              // We failed with the last attempted messagepart
              WriteLN('We were able to handle ' + IntToStr(Pred(iHandled)) + ' text/[something] -parts of the message.');
            end
            else
            begin
              // Not a single part??? Something very wrong with the provided message, I think.
              WriteLN('We were not able to handle any text/[something] -parts of the message.');
            end;
          end;
          WriteLN('');
        end;
      finally
        FreeAndNil(oMimeMessage);
      end;
    end;
  end;
end.
